﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Management;
using System.Xml.Linq;
using System.Runtime.InteropServices;
using System.IO.Ports;
using System.ComponentModel;
using System.Threading;
using System.Diagnostics;
using System.Security.Cryptography;
using static DeviceManager.Program.HardwareScan;

namespace DeviceManager
{
    internal class Program
    {
        static void Main(string[] args)
        {
            string key;
            Console.WriteLine("Please Enter:\n\t1 : GetHDinfo\t2:GetAllHDinfo\t3:IsHardwareOnline");
            while(true)
            {
                key = Console.ReadLine();
                if (key == "1")
                {
                    Console.WriteLine("Please Enter:\t0 : KeyboardPlate\t1:ChannelPlate\t2:PCIE");
                    string val = Console.ReadKey().ToString();
                    HardwareScan.HardwareType type = 0;
                    if (val == "0") type = HardwareScan.HardwareType.KeyboardPlate;
                    else if (val == "1") type = HardwareScan.HardwareType.ChannelPlate;
                    else if (val == "2") type = HardwareScan.HardwareType.PCIE;
                    Console.WriteLine();
                    HardwareScan.HardwareInfo info = HardwareScan.GetHDinfo(type);
                    if (info != null)
                    {
                        Console.WriteLine($"HardName:{info.HardName}\tClassGuid:{info.HardClassGuid}\t" +
                            $"Manufacturer:{info.HardManufacturer}\tDescription:{info.HardDescription}\t\tDeviceID:{info.HardDeviceID}\t\tPNPDeviceID:{info.HardPNPDeviceID}");
                    }
                }
                else if (key == "2")
                {
                    bool flag = false;
                    IEnumerator<HardwareScan.HardwareInfo> infos = HardwareScan.GetAllHDinfo();
                    while(infos.MoveNext())
                    {
                        flag = true;
                        var info = infos.Current;
                        Console.WriteLine($"HardName:{info.HardName}\tClassGuid:{info.HardClassGuid}\t" +
                                                $"Manufacturer:{info.HardManufacturer}\tDescription:{info.HardDescription}\t\tDeviceID:{info.HardDeviceID}\t\tPNPDeviceID:{info.HardPNPDeviceID}"); 
                    }
                    if(!flag) Console.WriteLine("Sorry, No Hardware Online!!!");
                }
                else if (key == "3")
                {
                    Console.WriteLine("Please Enter:\t0 : KeyboardPlate\t1:ChannelPlate\t2:PCIE");
                    string val = Console.ReadKey().ToString();
                    HardwareScan.HardwareType type = 0;
                    if (val == "0") type = HardwareScan.HardwareType.KeyboardPlate;
                    else if (val == "1") type = HardwareScan.HardwareType.ChannelPlate;
                    else if (val == "2") type = HardwareScan.HardwareType.PCIE;
                    Console.WriteLine();
                    bool ret = HardwareScan.IsHardwareOnline(type);
                }
                else if (key == "4")
                {
                    Console.WriteLine("------exit-----");
                    break;
                }
                Console.WriteLine();
                key = "";
            }
            //Console.WriteLine("------------------------------");
            //打印COM
            //SerialProtFindHelper.GetportCom();

            Console.ReadKey();

        }
        internal class HardwareScan
        {
            public enum HardwareType
            {
                KeyboardPlate,
                ChannelPlate,
                PCIE,
                TMC
            }
            private enum HardwareEnum
            {
                // 硬件
                Win32_Processor, // CPU 处理器
                Win32_PhysicalMemory, // 物理内存条
                Win32_Keyboard, // 键盘
                Win32_PointingDevice, // 点输入设备，包括鼠标。
                Win32_FloppyDrive, // 软盘驱动器
                Win32_DiskDrive, // 硬盘驱动器
                Win32_CDROMDrive, // 光盘驱动器
                Win32_BaseBoard, // 主板
                Win32_BIOS, // BIOS 芯片
                Win32_ParallelPort, // 并口
                Win32_SerialPort, // 串口
                Win32_SerialPortConfiguration, // 串口配置
                Win32_SoundDevice, // 多媒体设置，一般指声卡。
                Win32_SystemSlot, // 主板插槽 (ISA & PCI & AGP)
                Win32_USBController, // USB 控制器
                Win32_NetworkAdapter, // 网络适配器
                Win32_NetworkAdapterConfiguration, // 网络适配器设置
                Win32_Printer, // 打印机
                Win32_PrinterConfiguration, // 打印机设置
                Win32_PrintJob, // 打印机任务
                Win32_TCPIPPrinterPort, // 打印机端口
                Win32_POTSModem, // MODEM
                Win32_POTSModemToSerialPort, // MODEM 端口
                Win32_DesktopMonitor, // 显示器
                Win32_DisplayConfiguration, // 显卡
                Win32_DisplayControllerConfiguration, // 显卡设置
                Win32_VideoController, // 显卡细节。
                Win32_VideoSettings, // 显卡支持的显示模式。

                // 操作系统
                Win32_TimeZone, // 时区
                Win32_SystemDriver, // 驱动程序
                Win32_DiskPartition, // 磁盘分区
                Win32_LogicalDisk, // 逻辑磁盘
                Win32_LogicalDiskToPartition, // 逻辑磁盘所在分区及始末位置。
                Win32_LogicalMemoryConfiguration, // 逻辑内存配置
                Win32_PageFile, // 系统页文件信息
                Win32_PageFileSetting, // 页文件设置
                Win32_BootConfiguration, // 系统启动配置
                Win32_ComputerSystem, // 计算机信息简要
                Win32_OperatingSystem, // 操作系统信息
                Win32_StartupCommand, // 系统自动启动程序
                Win32_Service, // 系统安装的服务
                Win32_Group, // 系统管理组
                Win32_GroupUser, // 系统组帐号
                Win32_UserAccount, // 用户帐号
                Win32_Process, // 系统进程
                Win32_Thread, // 系统线程
                Win32_Share, // 共享
                Win32_NetworkClient, // 已安装的网络客户端
                Win32_NetworkProtocol, // 已安装的网络协议
                Win32_PnPEntity,//all device
            }

            /// <summary>
            /// 硬件信息
            /// </summary>
            public class HardwareInfo
            {
                private string mHardType;

                [Browsable(false)]
                [DisplayName("硬件类型")]
                public string HardType
                {
                    get { return mHardType; }
                    set { mHardType = value; }
                }

                private string mHardName;

                [Browsable(false)]
                [DisplayName("硬件名")]
                public string HardName
                {
                    get { return mHardName; }
                    set { mHardName = value; }
                }

                private string mHardDescription;

                [Browsable(false)]
                [DisplayName("硬件描述")]
                public string HardDescription
                {
                    get { return mHardDescription; }
                    set { mHardDescription = value; }
                }

                private string mHardClassGuid;

                [Browsable(false)]
                [DisplayName("全球唯一标识符")]
                public string HardClassGuid
                {
                    get { return mHardClassGuid; }
                    set { mHardClassGuid = value; }
                }

                private string mHardManufacturer;

                [Browsable(false)]
                [DisplayName("制造商")]
                public string HardManufacturer
                {
                    get { return mHardManufacturer; }
                    set { mHardManufacturer = value; }
                }

                private string mHardDeviceID;

                [Browsable(false)]
                [DisplayName("设备实例路径，DeviceId(地址或其他标识信息，以便唯一地命名逻辑设备)")]
                public string HardDeviceID
                {
                    get { return mHardDeviceID; }
                    set { mHardDeviceID = value; }
                }

                private string mHardPNPDeviceID;

                [Browsable(false)]
                [DisplayName("PNPDeviceId(指示逻辑设备的Win32即插即用设备标识符)")]
                public string HardPNPDeviceID
                {
                    get { return mHardDeviceID; }
                    set { mHardDeviceID = value; }
                }
            }

            private HardwareScan()
            {

            }

            /// <summary>
            /// 指定的设备是否在线（非通讯方式验证是否在线）
            /// </summary>
            /// <param name="type"></param>
            /// <returns></returns>
            public static bool IsHardwareOnline(HardwareType type)
            {
                string[] names = MulGetHardwareInfo(HardwareEnum.Win32_PnPEntity, "Name");
                string target = "Unknown";

                switch (type)
                {
                    case HardwareType.KeyboardPlate:
                        target = "USB-SERIAL CH340 (COM4)";
                        break;
                    case HardwareType.ChannelPlate:
                        target = "USB-SERIAL CH340 (COM2)";
                        break;
                    case HardwareType.PCIE:
                        target = "GHzScopeX Acquisition Device Driver";
                        break;
                    case HardwareType.TMC:
                        
                        break;
                    default:
                        target = "Unknown";
                        break;
                }
                if (names.Contains(target))
                {
                    Console.WriteLine($"设备在线\t{target}");
                    return true;
                }   
                else
                    Console.WriteLine($"设备不在线\t{target}\t\t{type}");
                return false;
            }


            /// <summary>
            /// 获取指定设备的信息(设备管理器中的信息汇总)
            /// </summary>
            /// <param name="type"></param>
            /// <returns></returns>
            public static HardwareInfo GetHDinfo(HardwareType type)
            {
                HardwareInfo info = new HardwareInfo();
                string name = "Unknown"; 
                switch (type)
                {
                    case HardwareType.KeyboardPlate:
                        name = "USB-SERIAL CH340 (COM4)";
                        break;
                    case HardwareType.ChannelPlate:
                        name = "USB-SERIAL CH340 (COM2)";
                        break;
                    case HardwareType.PCIE:
                        name = "GHzScopeX Acquisition Device Driver";
                        break;
                    case HardwareType.TMC:
                        break;
                    default:
                        name = "Unknown";
                        break;
                }
                
                using (ManagementObjectSearcher searcher = new ManagementObjectSearcher("root\\cimv2", "select * from Win32_PnPEntity"))
                {
                    var hardInfos = searcher.Get();
                    foreach (ManagementObject hardInfo in hardInfos)
                    {
                        string NAME = "";
                        if (hardInfo.Properties["Name"].Value != null)
                            NAME = hardInfo.Properties["Name"].Value.ToString();
                        else
                            continue;
                        string hardType = GetHardType(name);
                        if (NAME == name)
                        {
                            info.HardDescription = hardInfo.Properties["Description"].Value.ToString();
                            info.HardName = NAME;
                            info.HardDeviceID = hardInfo.Properties["DeviceId"].Value.ToString();
                            info.HardPNPDeviceID = hardInfo.Properties["PNPDeviceID"].Value.ToString();
                            info.HardClassGuid = hardInfo.Properties["ClassGuid"].Value.ToString();
                            info.HardManufacturer = hardInfo.Properties["Manufacturer"].Value.ToString();
                            info.HardType = hardType;
                            break;
                        }
                    }
                    searcher.Dispose();
                }
                return info;
            }

            /// <summary>
            /// 获取所有在线的示波器设备信息
            /// </summary>
            /// <returns></returns>
            public static IEnumerator<HardwareInfo> GetAllHDinfo()
            {
                List<HardwareInfo> allInfolist = new List<HardwareInfo>();
                List<string> names = new List<string>() { "USB-SERIAL CH340 (COM2)", "USB-SERIAL CH340 (COM4)", "GHzScopeX Acquisition Device Driver" };

                using (ManagementObjectSearcher searcher = new ManagementObjectSearcher("root\\cimv2", "select * from Win32_PnPEntity"))
                {
                    var hardInfos = searcher.Get();
                    foreach (ManagementObject hardInfo in hardInfos)
                    {
                        string NAME = "";
                        if (hardInfo.Properties["Name"].Value != null)
                            NAME = hardInfo.Properties["Name"].Value.ToString();
                        else
                            continue;
                        string hardType = GetHardType(NAME);
                        if (names.Contains(NAME))
                        {
                            HardwareInfo info = new HardwareInfo();
                            info.HardDescription = hardInfo.Properties["Description"].Value.ToString();
                            info.HardName = NAME;
                            info.HardDeviceID = hardInfo.Properties["DeviceId"].Value.ToString();
                            info.HardPNPDeviceID = hardInfo.Properties["PNPDeviceID"].Value.ToString();
                            info.HardClassGuid = hardInfo.Properties["ClassGuid"].Value.ToString();
                            info.HardManufacturer = hardInfo.Properties["Manufacturer"].Value.ToString();
                            info.HardType = hardType;
                            Console.WriteLine(NAME + "\n");
                            allInfolist.Add(info);
                        }
                    }
                    searcher.Dispose();
                }  
                return allInfolist.GetEnumerator();
            }

            /// <summary>
            /// 获取硬件类型
            /// </summary>
            /// <param name="name"></param>
            /// <returns></returns>
            private static string GetHardType(string name)
            {
                string hardType = "Unknown";
                if (name == "USB-SERIAL CH340 (COM4)")
                    hardType = "KeyboardPlate";
                else if (name == "USB-SERIAL CH340 (COM2)")
                    hardType = "ChannelPlate";
                else if (name == "GHzScopeX Acquisition Device Driver")
                    hardType = "PCIE";
                else if (name == "TMC")
                    hardType = "TMC";
                else    hardType = "Unknown";
                    
                return hardType;
            }

            /// <summary>
            /// WMI获取硬件信息 获取所有硬件类型为hardType的propKey值
            /// </summary>
            /// <param name="hardType"> WMI提供的API类.</param>
            /// <param name="propKey"> 想要获取的属性值.</param>
            /// <returns></returns>
            private static string[] MulGetHardwareInfo(HardwareEnum hardType, string propKey)
            {
                List<string> strs = new List<string>();
                try
                {
                    using (ManagementObjectSearcher searcher = new ManagementObjectSearcher("select * from " + hardType))
                    {
                        var hardInfos = searcher.Get();
                        foreach (ManagementObject hardInfo in hardInfos)
                        {
                            if (hardInfo.Properties[propKey].Value != null)
                                strs.Add(hardInfo.Properties[propKey].Value.ToString());
                        }
                        searcher.Dispose();
                    }
                    return strs.ToArray();
                }
                catch
                {
                    return strs.ToArray();
                }
            }
        }

        class SerialProtFindHelper
        {
            /// <summary>
            /// 枚举win32 api
            /// </summary>
            public enum HardwareEnum
            {
                // 硬件
                Win32_Processor, // CPU 处理器
                Win32_PhysicalMemory, // 物理内存条
                Win32_Keyboard, // 键盘
                Win32_PointingDevice, // 点输入设备，包括鼠标。
                Win32_FloppyDrive, // 软盘驱动器
                Win32_DiskDrive, // 硬盘驱动器
                Win32_CDROMDrive, // 光盘驱动器
                Win32_BaseBoard, // 主板
                Win32_BIOS, // BIOS 芯片
                Win32_ParallelPort, // 并口
                Win32_SerialPort, // 串口
                Win32_SerialPortConfiguration, // 串口配置
                Win32_SoundDevice, // 多媒体设置，一般指声卡。
                Win32_SystemSlot, // 主板插槽 (ISA & PCI & AGP)
                Win32_USBController, // USB 控制器
                Win32_NetworkAdapter, // 网络适配器
                Win32_NetworkAdapterConfiguration, // 网络适配器设置
                Win32_Printer, // 打印机
                Win32_PrinterConfiguration, // 打印机设置
                Win32_PrintJob, // 打印机任务
                Win32_TCPIPPrinterPort, // 打印机端口
                Win32_POTSModem, // MODEM
                Win32_POTSModemToSerialPort, // MODEM 端口
                Win32_DesktopMonitor, // 显示器
                Win32_DisplayConfiguration, // 显卡
                Win32_DisplayControllerConfiguration, // 显卡设置
                Win32_VideoController, // 显卡细节。
                Win32_VideoSettings, // 显卡支持的显示模式。

                // 操作系统
                Win32_TimeZone, // 时区
                Win32_SystemDriver, // 驱动程序
                Win32_DiskPartition, // 磁盘分区
                Win32_LogicalDisk, // 逻辑磁盘
                Win32_LogicalDiskToPartition, // 逻辑磁盘所在分区及始末位置。
                Win32_LogicalMemoryConfiguration, // 逻辑内存配置
                Win32_PageFile, // 系统页文件信息
                Win32_PageFileSetting, // 页文件设置
                Win32_BootConfiguration, // 系统启动配置
                Win32_ComputerSystem, // 计算机信息简要
                Win32_OperatingSystem, // 操作系统信息
                Win32_StartupCommand, // 系统自动启动程序
                Win32_Service, // 系统安装的服务
                Win32_Group, // 系统管理组
                Win32_GroupUser, // 系统组帐号
                Win32_UserAccount, // 用户帐号
                Win32_Process, // 系统进程
                Win32_Thread, // 系统线程
                Win32_Share, // 共享
                Win32_NetworkClient, // 已安装的网络客户端
                Win32_NetworkProtocol, // 已安装的网络协议
                Win32_PnPEntity,//all device
            }
            /// <summary>
            /// WMI取硬件信息
            /// </summary>
            /// <param name="hardType WMI提供的API类"></param>
            /// <param name="propKey 想要的属性值"></param>
            /// <returns></returns>
            private static string[] MulGetHardwareInfo(HardwareEnum hardType, string propKey)
            {
                List<string> strs = new List<string>();
                try
                {
                    using (ManagementObjectSearcher searcher = new ManagementObjectSearcher("select * from " + hardType))
                    {
                        var hardInfos = searcher.Get();
                        foreach (ManagementObject hardInfo in hardInfos)
                        {
                            //hardInfo.InvokeMethod("Enable", null); //启用
                            if (hardInfo.Properties[propKey].Value != null)
                                strs.Add(hardInfo.Properties[propKey].Value.ToString());
                            //if (hardInfo.Properties[propKey].Value != null && hardInfo.Properties[propKey].Value.ToString().Contains("COM"))
                            //{
                            //    strs.Add(hardInfo.Properties[propKey].Value.ToString());
                            //}

                        }
                        searcher.Dispose();
                    }
                    return strs.ToArray();
                }
                catch
                {
                    return strs.ToArray();
                }
            }

            

            /// <summary>
            /// 查找所有 WMI 类属性
            /// </summary>
            /// <param name="namespaceName"></param>
            /// <param name="wmiClassName"></param>
            public static void printWMIProp(string namespaceName = "root\\cimv2", string wmiClassName = "Win32_PnPEntity")
            {
                ManagementPath managementPath = new ManagementPath();
                managementPath.Path = namespaceName;
                ManagementScope managementScope = new ManagementScope(managementPath);
                ObjectQuery objectQuery = new ObjectQuery("SELECT * FROM " + wmiClassName);
                ManagementObjectSearcher objectSearcher = new ManagementObjectSearcher(managementScope, objectQuery);
                ManagementObjectCollection objectCollection = objectSearcher.Get();
                Console.WriteLine($"Property name\t\t\t\tProperty type\t\t\t\tProperty value");
                foreach (ManagementObject managementObject in objectCollection)
                {
                    PropertyDataCollection props = managementObject.Properties;
                    foreach (PropertyData prop in props)
                    {
                        Console.WriteLine($"{prop.Name}\t\t: {prop.Type} \t\t: {prop.Value}");
                    }
                }
                objectSearcher.Dispose();
            }

            /// <summary>
            /// 打印所有设备的指定属性信息
            /// </summary>
            public static void printAllDeviceInfo(string type = "HardwareID")
            {
                string[] names = MulGetHardwareInfo(HardwareEnum.Win32_PnPEntity, "Name");
                string[] deviceId = MulGetHardwareInfo(HardwareEnum.Win32_PnPEntity, type);//"HardwareID"
                int len = names.Length > deviceId.Length ? names.Length : deviceId.Length;
                for (int i = 0; i < len; ++i)
                {
                    Console.WriteLine($"{names[i]}\t\t\t {deviceId[i]}");
                }
            }          

            /// <summary>
            /// 查找端口
            /// </summary>
            public static void searchPort()
            {
                foreach (string portname in SerialPort.GetPortNames())
                {
                    SerialPort sp = new SerialPort(portname, 4800, Parity.Odd, 8, StopBits.One);
                    try
                    {
                        sp.Open();
                        sp.Write("Find SerialPort");
                        Thread.Sleep(500);
                        string received = sp.ReadLine();

                        if (received == "expected response")
                        {
                            Console.WriteLine("Phone connected to: " + portname);
                            break;
                        }
                    }
                    catch (Exception)
                    {
                        Console.WriteLine("Phone NOT connected to: " + portname);
                    }
                    finally
                    {
                        sp.Close();
                    }
                }
            }
        }
    }
}
